﻿
''' <summary>
''' Classe encapsulant toutes les caractéristiques attachées à une tuyauterie cuivre
''' </summary>
Public Class Cuivre
    ''' <summary>
    ''' Diamètre intérieur normalisé des tubes cuivre en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øint As New List(Of Double) From {0.008, 0.01, 0.012, 0.013, 0.014, 0.016, 0.018, 0.02, 0.023, 0.026, 0.03, 0.034, 0.04, 0.05, 0.051, 0.061, 0.0721, 0.0849, 0.103} 'diamètre intérieur tube cuivre
    ''' <summary>
    ''' Diamètre extérieur normalisé des tubes cuivre en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øext As New List(Of Double) From {0.01, 0.012, 0.014, 0.015, 0.016, 0.018, 0.02, 0.022, 0.025, 0.028, 0.032, 0.036, 0.042, 0.052, 0.054, 0.064, 0.0761, 0.0889, 0.108} 'diamètre extérieur tube cuivre
    ''' <summary>
    '''Nom normalisé des tubes cuivre en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Nom As New List(Of String) From {"10x1", "12x1", "14x1", "15x1", "16x1", "18x1", "20x1", "22x1", "25x1", "28x1", "32x1", "36x1", "42x1", "52x1", "54x1,5", "64x2", "76,1x2", "88,9x2", "108x2,5"} 'ref tube cuivre
End Class
''' <summary>
''' Classe encapsulant toutes les caractéristiques attachées à une tuyauterie en acier galvanisé
''' </summary>
Public Class AG
    ''' <summary>
    ''' Diamètre intérieur normalisé des tubes en Acier Galvanisé en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øint As New List(Of Double) From {0.0132, 0.0167, 0.0223, 0.0279, 0.0366, 0.0425, 0.0539, 0.07, 0.08, 0.1} 'diamètre intérieur tube acier galvanisé
    ''' <summary>
    ''' Diamètre extérieur normalisé des tubes en Acier Galvanisé en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øext As New List(Of Double) From {0.017, 0.021, 0.027, 0.034, 0.042, 0.049, 0.06, 0.076, 0.09, 0.115} 'diamètre intérieur tube acier galvanisé
    ''' <summary>
    '''Nom normalisé des tubes Acier Galvanisé en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Nom As New List(Of String) From {"12/17", "15/21", "20/27", "26/34", "33/42", "40/49", "50/60", "70/76", "80/90", "100/115"} 'ref tube acier galvanisé
End Class

''' <summary>
''' Classe encapsulant toutes les caractéristiques attachées à une tuyauterie Polyéthylène Réticulé
''' </summary>
Public Class PER
    ''' <summary>
    ''' Diamètre intérieur normalisé des tubes en Polyéthylène Réticulé en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øint As New List(Of Double) From {0.0098, 0.013, 0.0162, 0.0204, 0.0262, 0.0326, 0.0408, 0.0514, 0.0614, 0.0736} 'diamètre intérieur tube PER
    ''' <summary>
    ''' Diamètre extérieur normalisé des tubes en Polyéthylène Réticulé en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øext As New List(Of Double) From {0.012, 0.016, 0.02, 0.025, 0.032, 0.04, 0.05, 0.063, 0.075, 0.09} 'diamètre intérieur tube PER
    ''' <summary>
    '''Nom normalisé des tubes Polyéthylène Réticulé en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Nom As New List(Of String) From {"12x1,1", "16x1,5", "20x1,9", "25x2,3", "32x2,9", "40x3,7", "50x4,6", "63x5,8", "75x6,8", "90x8,2"} 'ref tube PER
End Class

''' <summary>
''' Classe encapsulant toutes les caractéristiques attachées à une tuyauterie multicouche
''' </summary>
Public Class Multi_Couche
    ''' <summary>
    ''' Diamètre intérieur normalisé des tubes en Multicouche en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øint As New List(Of Double) From {0.01, 0.012, 0.016, 0.02, 0.026} 'diamètre intérieur tube Multicouche
    ''' <summary>
    ''' Diamètre extérieur normalisé des tubes en Multicouche en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øext As New List(Of Double) From {0.014, 0.016, 0.02, 0.026, 0.032} 'diamètre extérieur tube Multicouche
    ''' <summary>
    '''Nom normalisé des tubes Multicouche en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Nom As New List(Of String) From {"14x2", "16x2", "20x2", "26x3", "32x3"} 'ref tube Multicouche
End Class

''' <summary>
''' Classe encapsulant toutes les caractéristiques attachées à une tuyauterie en PVC-C
''' </summary>
Public Class PVC_C
    ''' <summary>
    ''' Diamètre intérieur normalisé des tubes en PVC-C en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øint As New List(Of Double) From {0.0124, 0.0154, 0.0194, 0.0248, 0.031, 0.0388} 'diamètre intérieur tube PVC_C
    ''' <summary>
    ''' Diamètre extérieur normalisé des tubes en PVC-C en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øext As New List(Of Double) From {0.016, 0.02, 0.025, 0.032, 0.04, 0.05} 'diamètre extérieur tube PVC_C
    ''' <summary>
    '''Nom normalisé des tubes PVC-C en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Nom As New List(Of String) From {"12,4/16 DN16", "15,4/20  DN20", "19,4/25  DN25", "24,8/32  DN32", "31,0/40  DN40", "38,8/50  DN50"} 'ref tube PVC_C
End Class

''' <summary>
''' Classe encapsulant toutes les caractéristiques attachées à une tuyauterie en PVC pour réseau EU, EV et EP
''' </summary>
Public Class PVC
    ''' <summary>
    ''' Diamètre intérieur normalisé des tubes en PVC en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øint As New List(Of Double) From {0.069, 0.077, 0.084, 0.094, 0.1036, 0.1186, 0.133, 0.152, 0.1908, 0.2378, 0.3} 'diamètre intérieur tube PVC 
    ''' <summary>
    ''' Diamètre extérieur normalisé des tubes en PVC en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Øext As New List(Of Double) From {0.075, 0.08, 0.09, 0.1, 0.11, 0.125, 0.14, 0.16, 0.2, 0.25, 0.315} 'diamètre extérieur tube PVC 
    ''' <summary>
    '''Nom normalisé des tubes PVC en FRANCE - unité: m
    ''' </summary>
    Public ReadOnly Property Nom As New List(Of String) From {"Ø75x3", "Ø80x3", "Ø90x3", "Ø100x3", "Ø110x3,2", "Ø125x3,2", "Ø140x3,5", "Ø160x4", "Ø200x4,9", "Ø250x6,2", "Ø315x7,5"} 'ref tube PVC 
End Class