﻿Imports System.Math
Imports System.IO
Imports System.Xml.Serialization
Module General

    'Public Aff.msgResult As String 'Répertoire des notes de calculs
    'Public msgData As String 'Répertoire des
    'Public Redacteur As String
    'Public Chantier As String
    Public FichierAide As Integer = 0
    'Public Modele_Calcul As Integer '=1: dim. EF, =2: dim. ECS
    'Public Q_Name(24) As String
    'Public Q_EF(24), Q_EC(24), Di_EF(24), Di_EC(24), Y_App(24) As Double
    Public Nom_Cu() As String = {"12x1", "14x1", "15x1", "16x1", "18x1", "20x1", "22x1", "25x1", "28x1", "32x1", "36x1", "42x1", "52x1", "54x1,5", "64x2", "76,1x2", "88,9x2", "108x2,5"} 'ref tube cuivre
    Public Nom_Ag() As String = {"12/17", "15/21", "20/27", "26/34", "33/42", "40/49", "50/60", "70/76", "80/90", "100/115"} 'ref tube acier galvanisé
    Public Nom_PER() As String = {"12x1,1", "16x1,5", "20x1,9", "25x2,3", "32x2,9", "40x3,7", "50x4,6", "63x5,8", "75x6,8", "90x8,2"} 'ref tube PER
    Public Nom_MultiC() As String = {"14x2", "16x2", "20x2", "26x3", "32x3"} 'ref tube Multicouche
    Public Nom_PVC_C() As String = {"12,4/16 DN16", "15,4/20  DN20", "19,4/25  DN25", "24,8/32  DN32", "31,0/40  DN40", "38,8/50  DN50"} 'ref tube PVC_C
    Public Di_Cu() As Double = {0.01, 0.012, 0.013, 0.014, 0.016, 0.018, 0.02, 0.023, 0.026, 0.03, 0.034, 0.04, 0.05, 0.051, 0.061, 0.0721, 0.0849, 0.103} 'diamètre intérieur tube cuivre
    Public Di_Ag() As Double = {0.0132, 0.0167, 0.0223, 0.0279, 0.0366, 0.0425, 0.0539, 0.07, 0.08, 0.1} 'diamètre intérieur tube acier galvanisé
    Public Di_PVC_C() As Double = {0.0124, 0.0154, 0.0194, 0.0248, 0.031, 0.0388} 'diamètre intérieur tube PVC_C
    Public Di_PER() As Double = {0.0098, 0.013, 0.0162, 0.0204, 0.0262, 0.0326, 0.0408, 0.0514, 0.0614, 0.0736} 'diamètre intérieur tube PER
    Public Di_MultiC() As Double = {0.01, 0.012, 0.016, 0.02, 0.026} 'diamètre intérieur tube Multicouche
    Public TA_DN10() As Double = {0, 0.09, 0.137, 0.26, 0.48, 0.826, 1.26, 1.47} 'KV STAD DN10/09
    Public TA_DN15() As Double = {0.127, 0.212, 0.314, 0.571, 0.877, 1.38, 1.98, 2.52} 'KV STAD DN15/14
    Public TA_DN20() As Double = {0.511, 0.757, 1.19, 1.9, 2.8, 3.87, 4.75, 5.7} 'KV STAD DN20
    Public TA_DN25() As Double = {0.6, 1.03, 2.1, 3.62, 5.3, 6.9, 8, 8.7} 'KV STAD DN25
    Public TA_DN32() As Double = {1.14, 1.9, 3.1, 4.66, 7.1, 9.5, 11.8, 14.2} 'KV STAD DN32
    Public TA_DN40() As Double = {1.75, 3.3, 4.6, 6.1, 8.8, 12.6, 16, 19.2} 'KV STAD DN40
    Public TA_DN50() As Double = {2.56, 4.2, 7.2, 11.7, 16.2, 21.5, 26.5, 33} 'KV STAD DN50

    ''' <summary>
    ''' Classe encapsulant toutes les caractéristiques du réseau EFs ou ECS objet calcul
    ''' </summary>
    Public Reseau As New Installation

    Public Aff As New clsAffaire
    Public Exutoires As New List(Of Exutoire)
    Public T_Cu As New Cuivre
    Public T_AG As New AG
    Public T_PER As New PER
    Public T_PVC_C As New PVC_C
    Public T_MultiC As New Multi_Couche
    Public T_PVC As New PVC
    Public Function checkAscii(ByVal keyAscii As Integer) As Integer
        checkAscii = Abs(keyAscii)
        If keyAscii < 0 Then
            If Abs(keyAscii) = 44 Then
                Exit Function
            End If
        End If
        If Abs(keyAscii) = 8 Then Exit Function ' touche del utilisable
        If Abs(keyAscii) = 44 Then Exit Function
        If Abs(keyAscii) < 48 Or Abs(keyAscii) > 57 Then checkAscii = 0
    End Function
    Public Sub Gestion_Keypress(ByRef ee As System.Windows.Forms.KeyPressEventArgs, ByVal text1 As System.Windows.Forms.TextBox, _
                                ByVal positif As Boolean)
        Dim keyAscii As Integer
        keyAscii = Asc(ee.KeyChar)
        If text1.SelectionLength = text1.Text.Length Then
            text1.Clear()
        End If
        If keyAscii = Asc(".") Then
            text1.Text = text1.Text + ","
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("&") Then
            text1.Text = text1.Text + "1"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("é") Then
            text1.Text = text1.Text + "2"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = 34 Then ' code "
            text1.Text = text1.Text + "3"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("'") Then
            text1.Text = text1.Text + "4"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("(") Then
            text1.Text = text1.Text + "5"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If positif = True Then 'seulement si la valeur >0
            If keyAscii = Asc("-") Then
                text1.Text = text1.Text + "6"
                text1.SelectionStart = Len(text1.Text) + 1
                ee.Handled = True
                Exit Sub
            End If
        End If
        If keyAscii = Asc("è") Then
            text1.Text = text1.Text + "7"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("_") Then
            text1.Text = text1.Text + "8"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("ç") Then
            text1.Text = text1.Text + "9"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("à") Then
            text1.Text = text1.Text + "0"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        keyAscii = checkAscii(keyAscii)
        If keyAscii = 0 Then ee.Handled = True
    End Sub
    Public Sub Variables_generales() 'ByRef Q_Name() As String, ByRef Q_EF() As Double, ByRef Q_EC() As Double, ByRef Di_EF() As Double, ByRef Di_EC() As Double, ByRef Y_App() As Double)
        'Inscrit en dur dans le logiciel dans le cas d'une réinitialisation malheureuse ............

        With Aff
            .msgData = Directory.GetCurrentDirectory.ToString() & "\data" 'provisoire
            .msgResult = Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul"
            .i_data = 1
            .i_result = 1
            .Redacteur = "LeFux_Ingenierie"
            .Chantier = "A_définir"
            .Editeur = 1
        End With
    End Sub
    Public Sub Lecture_fichier_Ini(ByVal filename As String, ByRef Verif As Boolean)
        ', ByRef Q_Name() As String, ByRef Q_EF() As Double, ByRef Q_EC() As Double, ByRef Di_EF() As Double, ByRef Di_EC() As Double, ByRef Y_App() As Double
        Dim myStreamReader As StreamReader
        Dim toto, titi(20) As String ', tutu

        Verif = True
        Try
            myStreamReader = File.OpenText(filename)
            toto = myStreamReader.ReadLine 'on n'affecte aucune valeur sur la première ligne
            toto = myStreamReader.ReadLine 'ligne de commentaire
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Redacteur = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Chantier = CStr(titi(1))
            toto = myStreamReader.ReadLine  'ligne suivante
            Aff.msgResult = toto
            toto = myStreamReader.ReadLine   'ligne suivante
            Aff.msgData = toto
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.i_result = CInt(titi(1)) : Aff.i_data = CInt(titi(2))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Editeur = CInt(titi(1))
            toto = myStreamReader.ReadLine 'ligne de commentaire
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Reseau.Pr_ES = CDbl(titi(1)) : Reseau.Ycoef = CDbl(titi(2)) : Reseau.ΔT_ECS = CDbl(titi(3)) : Reseau.HMVC = CDbl(titi(4)) : Reseau.HMVrd = CDbl(titi(5))
            'For i = 0 To 24
            '    toto = myStreamReader.ReadLine  'ligne suivante
            '    Q_Name(i) = toto
            '    toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            '    Q_EF(i) = CDbl(titi(1)) : Q_EC(i) = CDbl(titi(2)) : Di_EF(i) = CDbl(titi(3)) : Di_EC(i) = CDbl(titi(3))
            'Next

        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "General: lecture fichier Ini")
            Verif = False
        Finally
            Erase titi
            If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
        End Try
    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(15), i, j, position As Integer
        Dim tutu As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
    Public Function Mise_en_Forme_date(ByVal Toto As String) As String
        Dim toti As String
        toti = Replace(Toto, "/", "_")
        Toto = Replace(toti, " ", "_")
        toti = Replace(Toto, ":", "_")
        Mise_en_Forme_date = toti
    End Function
    ''' <summary>Programme de gestion des touches pressées</summary>
    '''  <param name="positif">variable prenant la valeur Vrai si la valeur doit être un nombre positif</param>
    ''' <param name="entier"> variable prenant la valeur Vrai si la valeur doit être un entier</param>
    Public Sub Gestion_Keypress(ByRef ee As System.Windows.Forms.KeyPressEventArgs, ByVal text1 As System.Windows.Forms.TextBox,
                               ByVal positif As Boolean, ByVal entier As Boolean)
        Dim keyAscii As Integer
        keyAscii = Asc(ee.KeyChar)
        If text1.SelectionLength = text1.Text.Length Then
            text1.Clear()
        End If
        If keyAscii = Asc(".") Then
            If entier = False Then
                text1.Text = text1.Text + ","
                text1.SelectionStart = Len(text1.Text) + 1
            End If
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc(",") And entier = True Then
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("&") Then
            text1.Text = text1.Text + "1"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("é") Then
            text1.Text = text1.Text + "2"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = 34 Then ' code "
            text1.Text = text1.Text + "3"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("'") Then
            text1.Text = text1.Text + "4"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("(") Then
            text1.Text = text1.Text + "5"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If positif = True Then 'seulement si la valeur >0
            If keyAscii = Asc("-") Then
                text1.Text = text1.Text + "6"
                text1.SelectionStart = Len(text1.Text) + 1
                ee.Handled = True
                Exit Sub
            End If
        End If
        If keyAscii = Asc("è") Then
            text1.Text = text1.Text + "7"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("_") Then
            text1.Text = text1.Text + "8"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("ç") Then
            text1.Text = text1.Text + "9"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("à") Then
            text1.Text = text1.Text + "0"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        keyAscii = checkAscii(keyAscii)
        If keyAscii = 0 Then ee.Handled = True
    End Sub

#Region " Code de lecture du fichier de données "
#Region "Sérialization"
    ''' <summary>Routine sauvegardant les données objet par sérialization </summary>
    Public Sub SerializeData(ByVal i As Integer)
        Dim Fichier_Reseau As String = String.Empty
        Dim Fichier_Exutoire As String = String.Empty
        Dim Fichier_Affaire As String = String.Empty

        Dim myStreamWriter As StreamWriter = Nothing
        Try
            myStreamWriter = File.CreateText(Aff.FileName)
            Select Case i
                Case 1 'réseau EF ou ECS
                    myStreamWriter.WriteLine("réseau EF ou ECS - Fichiers de sauvegarde de l'affaire")
                    Fichier_Reseau = "réseau_EF_ECS_" & Mise_en_Forme_date(CStr(DateTime.Now))
                    myStreamWriter.WriteLine(Fichier_Reseau)
                    Fichier_Exutoire = "Exutoire_" & Mise_en_Forme_date(CStr(DateTime.Now))
                    myStreamWriter.WriteLine(Fichier_Exutoire)
                Case 2 'bouclage ECS
                    myStreamWriter.WriteLine("réseau BECS - Fichiers de sauvegarde de l'affaire")
                    Fichier_Reseau = "réseau_BECS_" & Mise_en_Forme_date(CStr(DateTime.Now))
                    myStreamWriter.WriteLine(Fichier_Reseau)
            End Select

            Fichier_Affaire = "Fichier_Affaire_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Affaire)
            myStreamWriter.Flush()
        Catch exc As Exception
            MessageBox.Show("Le fichier de sauvegarde ne peut être crée." + Environment.NewLine + "SVP, verifiez que le nom du fichier est correct, et que vouz avez la permission de lire ou d'écrire " +
              "dans le répertoire indiqué." + Environment.NewLine + Environment.NewLine + "Erreur: " + exc.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            ' fermer le fichier si pas de création possible
            If myStreamWriter IsNot Nothing Then myStreamWriter.Close()
        End Try
        'Sérialise les objets
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Reseau & ".xml", Reseau)
        If i = 1 Then Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Exutoire & ".xml", Exutoires)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Affaire & ".xml", Aff)

    End Sub
    Private Sub SerializeSysKeys(ByVal Path As String, ByVal Objet As Object)
        Try
            Call SaveXmlData(Path, Objet)
        Catch ex As Exception
            MessageBox.Show("Problème de sérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub SaveXmlData(ByVal Path As String, ByVal Objet As Object)
        Dim Type As Type = Objet.GetType
        Dim Serializeur As New XmlSerializer(Type)
        Dim Fi As New FileInfo(Path)
        If Fi.Directory.Exists = False Then System.IO.Directory.CreateDirectory(Fi.DirectoryName)
        'Sérialization
        Using fs As New FileStream(Path, FileMode.Create, FileAccess.Write)
            Serializeur.Serialize(fs, Objet)
            fs.Close()
        End Using
    End Sub
#End Region
#Region "Déserialization"
    ''' <summary>Routine lisant et affectant les données objet par sauvegardées par sérialization </summary>
    ''' 
    Public Sub DeSerializeData(ByVal i As Integer, ByVal Racine As String, ByRef Verif As Boolean)
        Dim toto, titi(20) As String
        Dim Fichier_Reseau As String = String.Empty
        Dim Fichier_Exutoire As String = String.Empty
        Dim Fichier_Affaire As String = String.Empty
        Dim myStreamReader As StreamReader = Nothing

        Try
            myStreamReader = File.OpenText(Aff.FileName)
            toto = myStreamReader.ReadLine 'barre de titre
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Reseau = CStr(titi(1))
            If i = 1 Then
                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
                Fichier_Exutoire = CStr(titi(1))
            End If
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Affaire = CStr(titi(1))
        Catch exc As Exception
            MessageBox.Show("Le fichier de sauvegarde ne peut être lu." + Environment.NewLine + "SVP, verifiez que le nom du fichier est correct, et que vouz avez la permission de lire ou d'écrire " +
              "dans le répertoire indiqué." + Environment.NewLine + Environment.NewLine + "Erreur: " + exc.Message, "Lecture des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False
        Finally
            ' fermer le fichier si pas de création possible
            If myStreamReader IsNot Nothing Then myStreamReader.Close()
        End Try
        'DéSérialise les objets
        If Racine + "\" <> Aff.msgData Then
            Call DeSerializeSysKeys(Racine & Fichier_Reseau & ".xml", Reseau, 1, Verif)
            If i = 1 Then Call DeSerializeSysKeys(Racine & Fichier_Exutoire & ".xml", Exutoires, 2, Verif)
            Call DeSerializeSysKeys(Racine & Fichier_Affaire & ".xml", Aff, 5, Verif)
        Else
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Reseau & ".xml", Reseau, 1, Verif)
            If i = 1 Then Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Exutoire & ".xml", Exutoires, 2, Verif)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Affaire & ".xml", Aff, 5, Verif)
        End If

    End Sub
    Private Sub DeSerializeSysKeys(ByVal Path As String, ByVal Objet As Object, ByVal i As Integer, ByRef Verif As Boolean)
        Try
            Call LoadXmlData(Path, Objet)
            Select Case i
                Case 1
                    Reseau = CType(Objet, Installation)
                Case 2
                    Exutoires = CType(Objet, List(Of Exutoire))
                Case 3
                    ' bet = CType(Objet, Beton)
                Case 4
                    '  Combinaisons = CType(Objet, List(Of Combinaison))
                Case 5
                    Aff = CType(Objet, clsAffaire)
            End Select

        Catch ex As Exception
            MessageBox.Show("Problème de Désérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Lecture des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False
        End Try
    End Sub
    Private Sub LoadXmlData(ByVal Path As String, ByRef Objet As Object)
        Dim Type As Type = Objet.GetType
        Dim Serializeur As New XmlSerializer(Type)
        Dim Fi As New FileInfo(Path)
        If Fi.Directory.Exists = False Then System.IO.Directory.CreateDirectory(Fi.DirectoryName)
        'Sérialization
        Using fs As New FileStream(Path, FileMode.Open, FileAccess.Read)
            Objet = Serializeur.Deserialize(fs)
            fs.Close()
        End Using
    End Sub
#End Region

    Private Sub Lecture_chaine(ByVal toto As String, ByRef titi() As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel)
        Dim blanc(20), i, j, position As Integer
        Dim tutu As String

        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        If titi(1) = "'" Then Exit Sub 'cette chaine correspond à un commentaire, sortie du programme
        'supprime tout commentaire dans la chaine
        position = InStr(1, toto, "'")
        If position <> 0 Then
            toto = Microsoft.VisualBasic.Left(toto, position - 1)
            toto = Trim(toto)
        End If
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
#End Region
End Module