﻿''' <summary>
''' Classe encapsulant tous les aspects généraux concernant l'affaire comme le projeteur, l'imprimante, etc. ...
''' </summary>
<Serializable()> Public Class clsAffaire

    Dim _FileName As String = String.Empty
    Dim _msgData As String = String.Empty
    Dim _msgResult As String = String.Empty
    Dim _i_result As Integer = 1
    Dim _i_data As Integer = 1
    Dim _Editeur As Integer = 1
    Dim _Modele_Calcul As Integer = 0
    ''' <summary>
    ''' nom du fichier de données
    ''' </summary>
    Public Property FileName As String
        Get
            FileName = _FileName
        End Get
        Set(value As String)
            If IsNumeric(value) = True Then
                Throw New ArgumentException("Le fichier ne peut pas être une valeur numérique.")
            Else
                _FileName = value
            End If
        End Set
    End Property
    ''' <summary>
    '''Répertoire du fichier de données
    ''' </summary>
    Public Property msgData As String '
        Get
            msgData = _msgData
        End Get
        Set(value As String)
            If IsNumeric(value) = True Then
                Throw New ArgumentException("Le fichier ne peut pas être une valeur numérique.")
            Else
                _msgData = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Répertoire des notes de calculs
    ''' </summary>
    Public Property msgResult As String '
        Get
            msgResult = _msgResult
        End Get
        Set(value As String)
            If IsNumeric(value) = True Then
                Throw New ArgumentException("Le fichier ne peut pas être une valeur numérique.")
            Else
                _msgResult = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' n° du répertoire des notes de calcul
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property i_result As Integer
        Get
            i_result = _i_result
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("Le n° du répertoire des notes de calcul n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La n° du répertoire des notes de calcul doit être supérieur ou  égal à 1.")
            Else
                _i_result = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' n° du répertoire du fichier de données
    ''' </summary>
    Public Property i_data As Integer
        Get
            i_data = _i_data
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("Le n° du répertoire du fichier de données n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La n° du répertoire du fichier de données doit être supérieur ou  égal à 1.")
            Else
                _i_data = value
            End If
        End Set
    End Property
    ''' <summary>
    '''nom du rédacteur
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Redacteur As String
    ''' <summary>
    ''' nom du chantier
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Chantier As String
    ''' <summary>
    ''' Editeur: 1=éditeur interne / 2=Word /
    ''' </summary>
    Public Property Editeur As Integer
        Get
            Editeur = _Editeur
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("Le n° de l'éditeur n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La n° de l'éditeur doit être supérieur ou  égal à 1.")
            Else
                _Editeur = value
            End If
        End Set
    End Property
    '''' <summary>
    '''' Modele_Calcul: 1=dimensionnement réseau Eau Froide sanitaire / 2=dimensionnement réseau Eau CHAUDE sanitaire
    '''' </summary>
    'Public Property Modele_Calcul As Integer
    '    Get
    '        Modele_Calcul = _Modele_Calcul
    '    End Get
    '    Set(value As Integer)
    '        _Modele_Calcul = value
    '    End Set
    'End Property

End Class
